jQuery(document).ready( function() 
{ 
	//jQuery( "#tabs" ).tabs();
	setPageTitle("HelpDesk");
	getHelpDeskMode();
	var currentTopicId = jQuery( "form#currentTopicId" )[0].currentTopicId.value;
	if ( currentTopicId == '' ) 
		showTopicTable( 'active' );
	else 
		showTopic( currentTopicId ); 
	setInterval( getHelpDeskMode, 600 * 1000 );
});

var lastMessageSize = 5;
var numfinput = 1;
var commMode = 0;
var commPhoneValue = "";
var commEmailValue = "";
var modes = [ "не оповещать",  "по телефону", "по e-mail" ];
var mode = "active";
var sendandclose = false;
var currentTopic;
var currentTopicList;
var currentStatusMap;
var userNameMap;
var webexecuter = "webexecuter";
var helpdeskModule = "ru.bitel.bgbilling.plugins.helpdesk";
var subcategoryMap;

function filechange()
{
	++numfinput;
	var g=document.getElementById('tdwithfileinput');
	var bre=document.createElement('br');
	g.appendChild(bre);
	var inpt=document.createElement('input');
	inpt.type="file";
	inpt.size=70;
	inpt.name="message_file_"+numfinput;
	inpt.onchange=filechange;
	g.appendChild(inpt);
}

function getHelpDeskMode()
{
	jQuery.get( webexecuter, { action: 'GetMode', module: helpdeskModule, mid: 0, contractId: contractId, ct: 'json' }, function( data )
	{
		if ( data.packages )
		{
			jQuery("input#helpDeskButtonPackages").show();
		}
	} );
}

function addHelpDeskTopic()
{
	jQuery.get( webexecuter, { action: 'AddTopic', module: helpdeskModule, mid: 0, contractId: contractId, ct: 'json' }, function( data )
	{
		if ( data.result ) 
		{ 
			setPageTitle("HelpDesk - Создание новой темы");
			var helpDeskAddTopic = showBlock("helpDeskAddTopic");
			var form = jQuery( "form", helpDeskAddTopic )[0];
			form.topic_title.value = '';
			form.message_body.value = '';
			document.getElementById('messageError').innerHTML = "";
			
			jQuery.get( webexecuter, { action: 'GetParam', module: helpdeskModule, mid: 0, contractId: contractId, ct: 'json' }, function( data ) 
			{
				commMode = data['comm.mode'];
				//
				var select = jQuery( form.elements['topic.comm.mode'] ).empty();
				jQuery("<option></option").attr( "value", "0" ).html( modes[0] ).appendTo( select );
				if ( data['default.comm.phone.enable'] == "true" )
				{
					commPhoneValue = data['comm.phone.value'];
					jQuery("<option></option").attr( "value", "1" ).prop( "defaultSelected", commMode == "1" ).html( modes[1] ).appendTo( select );
					form.elements['topic.comm.value'].value = commPhoneValue;
				}
				if ( data['default.comm.email.enable'] == "true" )
				{
					commEmailValue = data['comm.email.value'];
					jQuery("<option></option").attr( "value", "2" ).prop( "defaultSelected", commMode == "2" ).html( modes[2] ).appendTo( select );
					form.elements['topic.comm.value'].value = commEmailValue;
				}
				setTopicCommValue(form);

				var category = jQuery( form.elements['topic.comm.category'] ).empty();
				var mas = data['categoryList'];
				if( mas && mas.length > 0 )
				{// заполним выпадающий список категориями.
					for (var i=0; i<mas.length; i++) {
						jQuery("<option></option").attr( "value", mas[i].id ).html( mas[i].title ).appendTo( category );
					}
					subcategoryMap = data['subCategoryMap'];// сохраним подкатегории
					loadSubcategory(form);// заполним и для подкатегорий.
				}
				else	{
					document.getElementById('categoryDiv').style.display = 'none';//скроем выбор категорий.
				}
				
				// Заполнение списка доп. информации, котороя в дальнейшем будет прикрепленно к названию темы
				var addTextValues = jQuery( form.elements['topic.additionalTextToSubject.values'] ).empty();
				var masATV = data['addTextValues'];
				if( masATV && masATV.length > 0 )
				{
					for (var i=0; i<masATV.length; i++) {
						jQuery("<option></option").attr( "value", masATV[i] ).html( masATV[i] ).appendTo( addTextValues );
					}
					document.getElementsByName("topic.additionalTextToSubject.title")[0].innerHTML = data['addTextTitle'];
				}
				else	{
					document.getElementById('additionalTextDiv').style.display = 'none';//скроем выбор доп информации.
				}
			} );
		}
		else 
			showHelpDeskTopicError( data.error );
	} );
}

/** Подгружаем подкатегории для выбранной категории.*/
function loadSubcategory( form )
{
	var idCategory = form.elements['topic.comm.category'].value;
	var listSub = subcategoryMap[idCategory];
	var subcategory = jQuery( form.elements['topic.comm.subcategory'] ).empty();

	for (var i=0; i < listSub.length; i++) {
		jQuery("<option></option").attr( "value", listSub[i].id ).html( listSub[i].title ).appendTo( subcategory );
	}
}

/** Вызывается при выборе подкатегории. Тут шлется запрос на сервер, где в свою очередь бросается событие. */
function selectedSubcategory( form )
{
	if( subcategoryMap )// если его нет, то значит категорий нет, то и парится не стоит.
	{
		var idCategory = form.elements['topic.comm.category'].value;
		var idSubCategory = form.elements['topic.comm.subcategory'].value;
		if( idCategory == -1 || idSubCategory == -1 )
			return;
		var title = document.getElementsByName('topic_title')[0].value;

		jQuery.get( webexecuter, { action:'UpdateTopic', module:helpdeskModule, mid:0, contractId:contractId, ct:'json', 'topic.comm.category':idCategory, 'topic.comm.subcategory':idSubCategory, 'topic_title':title, round:1 }, function( data )
		{
			var button = document.getElementById('buttonSendToNewTopic');
			button.disabled = !data.result;
			
			var errorText = document.getElementById('messageError');
			if( data.errorMessage )
				errorText.innerHTML = data.errorMessage;
			else
				errorText.innerHTML = "";
		} );
	}
}

/** Создаем тему. Все данные в форме, тут только проверим категории. */
function updateHelpDeskTopic(form)
{
	var idCategory = form.elements['topic.comm.category'].value;
	var idSubCategory = form.elements['topic.comm.subcategory'].value;
	
	if( subcategoryMap )
	{
		if( idCategory == -1 || idSubCategory == -1 )
		{
			showHelpDeskTopicError( 'didNotSetCategory' );
			return;
		}
	}
	
	jQuery(form).ajaxSubmit( function( data ) 
	{
		if ( data.result )
		{
			showTopic( data.topic.id );
		}
		else
			showHelpDeskTopicError( data.error );
	} );
}

function showHelpDeskTopicError(error)
{
	if ( error == 'offMode' ) alert( "У Вас нет доступа к этой функции" ); 
	else if ( error == 'activePackageNotFound' ) alert( "Ошибка: Функция создания новой темы - НЕДОСТУПНА, т.к. нет активных пакетов." ); 
	else if ( error == 'bodyNotEmpty' ) alert( "Ошибка: Cообщение должно быть непустым." ); 
	else if ( error == 'noStatusNoClose' ) alert( "Ошибка: К сожалению, Вы не можете закрыть тему, статус которой не установлен менеджером." );
	else if ( error == 'subjectNotEmpty' ) alert( "Дайте название теме !" );
	else if ( error == 'didNotSetCategory' ) alert( "Не выбрана категория/подкатегория" );
	else alert( "Ошибка:" + error ); 
}

function setTopicCommValue(form)
{
	var mode = form.elements['topic.comm.mode'].value;
	if ( mode == "0" )
	{
		jQuery(form.elements['topic.comm.value']).hide();
	}
	else if ( mode == "1" )
	{
		form.elements['topic.comm.value'].value = commPhoneValue;
		jQuery(form.elements['topic.comm.value']).show();
	}
	else if ( mode == "2" )
	{
		form.elements['topic.comm.value'].value = commEmailValue;
		jQuery(form.elements['topic.comm.value']).show();
	}
}

function showTopicTable( mode )
{
	this.mode = mode;
	setPageTitle( mode == "active" ? "HelpDesk - Активные темы" : "HelpDesk - Архив" );
	setTopicListFilter( jQuery( "div#topicList form" )[0] );
}

function setTopicListFilter( form )
{
	getTopicList( {
		action: 'GetTopicList',
		module: helpdeskModule,
		mode: mode, 
		mid: 0,
		tid: form.topicId.value,
		topic: form.topicTitle.value,
		date1: form.date1.value,
		date2: form.date2.value,
		searchString: form.searchString.value,
		contractId: form.contractId.value, 
		ct: 'json'
	} );
}

function resetTopicListFilter( form )
{
	jQuery(form).clearForm();
	setTopicListFilter( form );
}

function getTopicList( requestParam )
{
	var topicListDiv = showBlock("topicList")[0];
	jQuery("div#topicItemParam").hide();
	var infoMessage = jQuery("<div class=\"infoMessage\">Выполняется запрос, пожалуйста подождите.</div>").appendTo( jQuery("body") );
	var tbody = jQuery("table#topicTable tbody", topicListDiv).empty()[0];
	var topicItemList = jQuery("div#topicItemList", topicListDiv);
	topicItemList[0].innerHTML="";
	jQuery.get( webexecuter, requestParam, function( data ) 
	{ 
		var topicItem = jQuery("div#topicItem", topicListDiv);
		currentTopicList = data.topicList;
		currentStatusMap = data.statusMap;
		for (i=0; i<data.topicList.length; i++)
		{
			var topic = data.topicList[i];
			var title = "<a href='#' onclick='showTopic( " + topic.id + ")'>" + topic.title + "</a>";
			if ( topic.messageNewManagerCount > 0 ) title = title + " <sup class='new colorNew'>[ НОВЫХ => " + topic.messageNewManagerCount + " ]</sup>";
			// list item
			var item = topicItem.clone();
			jQuery("span#topicItemId",item).html("#"+topic.id);
			jQuery("div#topicItemTitle",item).html(title);
			jQuery("span#topicItemDownload",item).html("[ <a href='?action=DownloadTopic&module=ru.bitel.bgbilling.plugins.helpdesk&mid=0&id=" + topic.id + "&contractId=" + requestParam.contractId +"' class=\"colorLink\">сохранить</a> ]");
			jQuery("span#topicItemShowHideParam",item).html("[ <a href=\"#\" class=\"colorLink\" onclick=\"return topicItemShowHideParam("+i+",this)\">параметры</a> ]");
			jQuery("span#topicItemURL",item).html("[ <a class='colorLink' href='?action=HelpDeskAJAX&mid=0&module=ru.bitel.bgbilling.plugins.helpdesk&contractId=" + contractId + "&topicId=" + topic.id + "'>URL темы</a> ]");
			item.show().appendTo(topicItemList);
			//jQuery("div.HelpDeskTopicListItemParam",item).attr("id","topicItemParam_"+topic.id);
			// table
//			var tr = jQuery("<tr></tr>");
//			jQuery("<td></td>").html(topic.id).appendTo(tr);
//			jQuery("<td></td>").html( title ).appendTo(tr);
//			jQuery("<td></td>").html( getComm( topic.comm, topic.commValue ) ).appendTo(tr);
//			jQuery("<td></td>").html( parseDate(topic.date) + "<br/>[" + parseDate(topic.dateClose) + "]" ).appendTo(tr);
//			jQuery("<td></td>").html( ( topic.closed ? "закрыта" : "открыта" ) + "<br/>[" + checkValue( data.statusMap[topic.status], "-" ) + "]" ).appendTo(tr);
//			jQuery("<td></td>").html( checkValue( data.cost, "-" ) ).appendTo(tr);
//			jQuery("<td></td>").html( checkValue( data.inpackage, "-" ) ).appendTo(tr);
//			jQuery("<td></td>").html( "<a href='?action=DownloadTopic&module=ru.bitel.bgbilling.plugins.helpdesk&mid=0&id=" + topic.id + "&contractId=" + requestParam.contractId +"'>сохранить</a>" ).appendTo(tr);
//			tr.appendTo(tbody);
		};
		infoMessage.remove();
	} );
}

function topicItemShowHideParam( index, tag )
{
	var topic = currentTopicList[index];
	var item = jQuery("div#topicItemParam").hide();
	jQuery("span#topicItemId",item).html("#"+topic.id);
	jQuery("span#topicItemNotify",item).html(getComm(topic.comm,topic.commValue));
	jQuery("span#topicItemStatus",item).html(checkValue( currentStatusMap[topic.status], "-" ));
	jQuery("span#topicItemState",item).html(topic.closed?"закрыта":"открыта");
	jQuery("span#topicItemDateCreate",item).html(parseDate(topic.date));
	jQuery("span#topicItemDateClose",item).html(parseDate(topic.dateClose));
	jQuery("span#topicItemCost",item).html(checkValue(topic.cost,"-"));
	jQuery("span#topicItemInPackage",item).html(checkValue(topic.inpackage,"-"));
	var objLeft = tag.offsetLeft;
	var objTop  = tag.offsetTop;
	var objParent = tag.offsetParent;
	while ( objParent.tagName.toUpperCase() != "BODY" )
	{
		objLeft  += objParent.offsetLeft;
		objTop   += objParent.offsetTop;
		objParent = objParent.offsetParent;
	}
	var xPos=objLeft;
	var yPos=objTop + tag.offsetHeight;
	item[0].style.display = "";
	item[0].style.top = yPos + "px";
	item[0].style.left = xPos + "px";
	item[0].style.visibility = "visible";
	return false;
}

function showPopupMenu( tag, menuId )
{
	hideAllPopup();
	var objLeft = tag.offsetLeft;
	var objTop  = tag.offsetTop;
	var objParent = tag.offsetParent;
	while ( objParent.tagName.toUpperCase() != "BODY" )
	{
		objLeft  += objParent.offsetLeft;
		objTop   += objParent.offsetTop;
		objParent = objParent.offsetParent;
	}
	var xPos=objLeft;
	var yPos=objTop + tag.offsetHeight;
	var menu = document.getElementById( menuId );
	if ( menu != null )
	{
		menu.style.display = "";
		menu.style.top = yPos + "px";
		menu.style.left = xPos + "px";
		menu.style.visibility = "visible";
	}
}


function showTopic( topicId )
{
	jQuery.get( webexecuter, { action: 'GetTopic', module: helpdeskModule, id: topicId, mid: 0, contractId: contractId, ct: 'json' }, function(data) { initTopicData( data, false ) } );
}

function initTopicData( data, showNew )
{
	setPageTitle( "HelpDesk - Переписка" );
	var topicData = showBlock("topicData")[0];
	jQuery( topicData ).hide();
	//
	currentTopic = data.topic;
	userNameMap = data.userNameMap;
	messageFileMap = data.messageFileMap;
	jQuery("span#topicId", topicData).html( "#" + currentTopic.id );
	jQuery("span#topicStatus", topicData).html( currentTopic.closed ? "Закрыта" : "Активна" );
	jQuery("span#topicDate", topicData).html( parseDate( currentTopic.date ) );
	jQuery("span#topicComm", topicData).html( getComm( currentTopic.comm, currentTopic.commValue ) );
	jQuery("span#topicUser", topicData).html( userNameMap[ currentTopic.userId ] );
	jQuery("a#topicURL", topicData).attr( "href", "?action=HelpDeskAJAX&mid=0&module=ru.bitel.bgbilling.plugins.helpdesk&contractId=" + contractId + "&topicId=" + currentTopic.id ).html( "ссылка" );
	jQuery("span#topicTitle", topicData).html( currentTopic.title );
	jQuery("span#topicCost", topicData).html( currentTopic.cost );
	setHelpDeskTopicMessageList( topicData );
	if ( currentTopic.closed )
	{
		jQuery("div#topicReplyButton", topicData).hide();
	}
	else
	{
		jQuery("div#topicReplyButton", topicData).show();
	}
	if ( showNew )
	{
		topicMessageNew( "", topicData );
	}
	else
	{
		jQuery("div#topicMessageNew", topicData).hide();
		jQuery("div#topicMesssageList", topicData).show();
		jQuery("div#topicMesssageFilter", topicData).show();
	}
	jQuery( topicData ).show();
}

function setHelpDeskTopicMessageList( topicData )
{
	if ( !topicData ) topicData = jQuery("div#topicData");
	var messageListPoint = jQuery("div#topicMesssageList", topicData).empty().show()[0];
	var messageTable = jQuery("table#topicMessage", topicData )[0];
	var topicMessagesLength = currentTopic.messages.length;
 	for (i=0; i<topicMessagesLength; i++)
	{
		var message = currentTopic.messages[i];
		if ( lastMessageSize > 0 && i < currentTopic.messages.length - lastMessageSize ) continue;
		if ( lastMessageSize == -2 && message.userIdFrom == 0 ) continue;
		if ( lastMessageSize == -3 && message.userIdFrom != 0 ) continue;
		var cl = jQuery(messageTable).clone();
		if (message.userIdFrom > 0 && message.userIdTo == -1 ) jQuery( "span#messageNew", cl ).html( "НОВОЕ!!!" );
		jQuery( "span#messageN", cl ).html( (i + 1) + " из " + topicMessagesLength );
		jQuery( "span#messageId", cl ).html( "#" + message.id );
		jQuery( "span#messageFrom", cl ).html( userNameMap[ message.userIdFrom ] + " в " + parseDate( message.dateFrom ) );
		jQuery( "span#messageTo", cl ).html( userNameMap[ message.userIdTo ] + " в " + parseDate( message.dateTo ) );
		var messageText = message.body.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		if ( messageText.length > 200 ) messageText = messageText.substring( 0, 200 ) + "<span id='showNextText' style='padding-left: 1em; font-size: 70%;'>[<a href='#' onclick='showNextText(this); return false;' style='padding: 0px 3px;'>показать далее</a>]</span><span style='display: none'>" + messageText.substring( 200 ) + "</span>";
		jQuery( "div.HelpDeskTopicMessageText", cl ).html( messageText.replace(/\n/g, "<br/>") );
		if ( message.userIdFrom != 0 )
		{
			jQuery( "div.HelpDeskTopicMessageText", cl ).css( "padding-left", "50px" );
			if ( mode == 'active' ) jQuery( "span#messageReply", cl ).html( "[<a href=\"#\" onclick=\"replyHelpDeskTopicMessage( " + message.id + " ); return false;\">ответить</a>]" );
		}
		//
		var files = messageFileMap[message.id];
		if ( files.length > 0 )
		{
			var str = "";
			for (f=0; f<files.length; f++)
			{
				var file = files[f];
				str = str + "<span id=\"topicMessageFile_" + file.id + "\" style='padding-right: 2em;'>";
				str = str + "<img src=\"img/attach.png\" alt=\"прикреплено\"/>";
				str = str + "<a href=\"?action=FileDownload&mid=0&module="+helpdeskModule+"&id=" + file.id + "&contractId=" + contractId +"\" style=\"text-decoration: underline;\">";
				str = str + file.title;
				str = str + "</a> (" + file.size + " байт) ";
				if ( message.userIdFrom == 0 ) str = str + "<a href=\"#\" onclick=\"return deleteHelpDeskMessageFile( " + file.id + " )\">Удалить</a>";
				str = str + "</span>";
			}
			jQuery( "div#messageFile", cl ).html( str );
		}
		cl.css( { position: "static" } );
		cl.appendTo( messageListPoint );
	}
}

function helpDeskTopicMessageFilter( tag, size )
{
	lastMessageSize = size;
	setHelpDeskTopicMessageList();
	jQuery(tag).parent().find("a").css("font-weight","normal").end().end().css("font-weight","bold");
}

function helpDeskTopicClose()
{
	if ( confirm( "Вы уверены, что хотите закрыть тему?" ) )
	{
		jQuery.get( webexecuter, { action: 'UpdateTopicClose', module: helpdeskModule, topicId: currentTopic.id, mid: 0, contractId: contractId, ct: 'json' }, function(data)
		{
			if ( data.result ) showTopicTable( 'active' ); else showHelpDeskTopicError( data.error );
		} );
	}
}

function deleteHelpDeskMessageFile( fileId )
{
	if ( confirm( "Вы уверены, что хотите удалить файл?" ) )
	{
		jQuery.get( webexecuter, { action: 'FileDelete', module: helpdeskModule, id: fileId, mid: 0, ct: 'json' }, function( data ) 
		{
			if ( data.result ) jQuery("div#topicData span#topicMessageFile_" + fileId ).empty();
		} );
	}
	return false;
}

function showHelpDeskParam( contractId )
{
	setPageTitle("HelpDesk - Параметры");
	var helpDeskParam = showBlock("helpDeskParam");
	jQuery.get( webexecuter, { action: 'GetParam', module: helpdeskModule, mid: 0, contractId: contractId, ct: 'json' }, function( data ) 
	{
		commMode = data['comm.mode'];
		//
		var form = jQuery( "form", helpDeskParam )[0];
		jQuery(form.save).hide();
		//
		var select = jQuery( form.elements['default.comm.mode'] ).empty();
		jQuery("<option></option").attr( "value", "0" ).html( modes[0] ).appendTo( select );
		jQuery( "span#currentCommMode", helpDeskParam ).html( modes[ commMode ] );
		if ( data['default.comm.phone.enable'] == "true" )
		{
			commPhoneValue = data['comm.phone.value'];
			jQuery("<option></option").attr( "value", "1" ).prop( "defaultSelected", commMode == "1" ).html( modes[1] ).appendTo( select );
			jQuery( "span#currentCommPhoneValue", helpDeskParam ).html( commPhoneValue );
			form.elements['comm.phone.value'].value = commPhoneValue;
		}
		else
		{
			jQuery("tr#commPhoneValue", helpDeskParam ).hide();
		}
		if ( data['default.comm.email.enable'] == "true" )
		{
			commEmailValue = data['comm.email.value'];
			jQuery("<option></option").attr( "value", "2" ).prop( "defaultSelected", commMode == "2" ).html( modes[2] ).appendTo( select );
			jQuery( "span#currentCommEmailValue", helpDeskParam ).html( commEmailValue );
			form.elements['comm.email.value'].value = commEmailValue;
		}
		else
		{
			jQuery("tr#commEmailValue", helpDeskParam ).hide();
		}
	} );
}

function showHelpDeskParamSaveButton( form )
{
	var showButton = false;
	showButton = form.elements['default.comm.mode'].value != commMode;
	if ( !showButton ) showButton = form.elements['comm.phone.value'].value != commPhoneValue;
	if ( !showButton ) showButton = form.elements['comm.email.value'].value != commEmailValue;
	if ( showButton ) jQuery(form.save).show(); else jQuery(form.save).hide();
}

function saveHelpDeskParam( form )
{
	jQuery(form).ajaxSubmit( function( data ) { if ( data.result ) showHelpDeskParam( form.contractId.value ); } );
}

function replyHelpDeskTopicMessage( messageId )
{
	for (i=0; i<currentTopic.messages.length; i++)
	{
		var message = currentTopic.messages[i];
		if ( message.id != messageId ) continue;
		topicMessageNew( message.body );
		break;
	}
}

function topicMessageNew( messageBodyText, topicData )
{
	if ( !topicData ) topicData = jQuery("div#topicData");
	jQuery("div#topicMesssageFilter", topicData).hide();
	jQuery("div#topicMesssageList", topicData).hide();
	jQuery("div#topicReplyButton", topicData).hide();
	var topicMessageNew = jQuery("div#topicMessageNew", topicData).show();
	
	var form = jQuery("form", topicMessageNew)[0];
	if ( !messageBodyText ) messageBodyText = "";
	if ( messageBodyText != "" ) messageBodyText = ">" + messageBodyText.replace(/\n/g, "\n>") + "\n\n";
	form.message_body.value = messageBodyText;
	form.topicId.value = currentTopic.id;
	
	numfinput = 1;
	jQuery("input:file", topicMessageNew).remove();
	jQuery("div#tdwithfileinput", topicMessageNew).append( "<input type=\"file\" name=\"message_file_1\" size=\"70\" onchange=\"filechange();\" />" );
}

function sendTopicMessageNew( form )
{
	jQuery("div#topicMessageNew iframe").load(function() { finishTopicMessageNew(); } );
	form.submit();
}

function finishTopicMessageNew()
{
	var form = jQuery("div#topicMessageNew form")[0];
	showTopic( form.topicId.value, form.contractId.value ); 
}

function showHelpDeskPackage( contractId )
{
	setPageTitle("HelpDesk - Пакеты");
	var packageDiv = showBlock( "helpDeskPackage" );
	jQuery.get( webexecuter, { action: 'GetPackage', module: helpdeskModule, mid: 0, contractId: contractId, ct: 'json' }, function( data ) 
	{
		var tbody = jQuery("div.report table tbody",packageDiv).empty();
		for (i=0; i<data.contractPackageList.length; i++)
		{
			var pkg = data.contractPackageList[i];
			var tr = jQuery("<tr/>");
			jQuery("<td/>").css("text-align","right").html(pkg.id).appendTo(tr);
			jQuery("<td/>").html(formatDate(pkg.dateFrom)+"-"+formatDate(pkg.dateTo)).appendTo(tr);
			jQuery("<td/>").css("text-align","right").html(pkg.summa).appendTo(tr);
			jQuery("<td/>").css("text-align","right").html(pkg.count+" ["+pkg.countUse+"]").appendTo(tr);
			jQuery("<td/>").css("text-align","center").html(data.activePackageMap[pkg.id]?"да":"нет").appendTo(tr);
			jQuery("<td/>").css("text-align","center").html(pkg.userId>0?"Администратор":"Пользователь").appendTo(tr);
			tr.appendTo(tbody);
		}
		var list = jQuery("div#helpDeskPackageList",packageDiv).empty();
		var listItem = jQuery("div#helpDeskPackageListItem",packageDiv);
		for (i=0; i<data.packageList.length; i++)
		{
			var pkg = data.packageList[i];
			var item = listItem.clone();
			var a = jQuery("<a/>").attr("href","#").attr("onclick","return addHelpDeskPackage("+pkg.id+","+contractId+")").html(pkg.title);
			jQuery("div#packageItemTitle",item).html(a);
			jQuery("span#packageItemPeriod",item).html(data.periodPackageMap[pkg.id]+" ["+pkg.period+"]");
			jQuery("span#packageItemCount",item).html(pkg.count);
			jQuery("span#packageItemSumma",item).html(pkg.summa);
			item.appendTo(list).show();
		}
	} );
}

function addHelpDeskPackage( packageId, contractId )
{
	if ( confirm( 'Вы уверены, что хотите активировать выбранный пакет?' ) )
	{
		jQuery.get( webexecuter, { action: 'AddPackage', module: helpdeskModule, mid: 0, packageId: packageId, contractId: contractId, ct: 'json' }, function( data ) 
		{
			if ( data.result ) { showHelpDeskPackage( contractId ); } else
			{
				if ( data.error == 'packageIdNotFound' ) alert( "Пакет не выбран" ); 
				else if ( data.error == 'packageNotFound' ) alert( "Пакет не существует" ); 
				else if ( data.error == 'packageStatusDisabled' ) alert( "packageStatusDisabled" ); 
				else if ( data.error == 'balanceNotValid' ) alert( "На счете не достаточно средств для активации пакета" ); 
				else if ( data.error == 'chargeNotFound' ) alert( "Расход не существует" ); 
			}	
		} );
	}
	return false;
}

function showBlock( name )
{
	if ( name != "topicList" ) jQuery("div#topicList").hide();
	if ( name != "topicData" ) jQuery("div#topicData").hide();
	if ( name != "helpDeskParam" ) jQuery("div#helpDeskParam").hide();
	if ( name != "helpDeskPackage" ) jQuery("div#helpDeskPackage").hide();
	if ( name != "helpDeskAddTopic" ) jQuery("div#helpDeskAddTopic").hide();
	return jQuery("div#"+name).show();
}

function getComm( comm, commValue )
{
	var result = "";
	if ( comm == 0 ) { result = result + "-"; }
	else if ( comm < 3 ) { result = result + modes[comm] + ": " + commValue; }
	return result;
}

function checkValue( value, defaultValue )
{
	var result = defaultValue;
	if ( value != undefined )
	{
		result = value;
	}
	return result;
}

function parseDate( inDate )
{
	var result = "н/д";
	if ( inDate != undefined )
	{
		var arr = inDate.split( " " );
		var date = Date.parse( arr[0] + ", " + arr[2] + " " + arr[1] + " " + arr[5] + " " + arr[3] );
		if ( date != undefined )
		{
			var dd = new Date();
			dd.setTime(date);
			result = dd.toLocaleString();
		}
	}
	return result;
}

function formatDate( date )
{
	return date.substring(8)+"."+date.substring(5,7)+"."+date.substring(0,4);
}

function showNextText( tag )
{
	jQuery(tag).parent().next().show().end().remove();
}

function showNextTextAll()
{
	jQuery( "span#showNextText" ).remove();
	jQuery( "div.HelpDeskTopicMessageText span" ).show();
}
